/* $Id: cells.c,v 1.2 2001/04/06 18:17:22 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * cells.c: convert cell blocks to raw blocks
 */

#include "testbench.h"
#include <stdlib.h>

extern unsigned char calc_hec (unsigned long header);

StreamBlock *CellFilter (StreamBlock *block)
{
  DataBlock *data = NewDataBlock ();
  unsigned long header;
  unsigned vci = 1;
  unsigned pti = 0;
  unsigned islast = 0;
  unsigned count;

  /* we only handle cell blocks */
  if (block->btype != CELL)
    return block;

  /* check options */
  if (block->options) {
    sscanf (block->options, "%d %d", &vci, &islast);
    pti |= islast ? 1 : 0;
    /* raw doesn't have options */
    free (block->options);
    block->options = NULL;
  }

  /* create ATM header */
  header = (vci << 4) | (pti << 1);
  AddToDataBlock (data, header);
  AddToDataBlock (data, calc_hec(header)<<24);

  /* copy payload */
  for (count=0; count<block->data->entries; count++)
    AddToDataBlock (data, block->data->data[count]);

  /* pad to 12 words */
  while (data->entries < 14)
    AddToDataBlock (data, 0L);

  /* delete old block */
  DeleteDataBlock (block->data);
  
  /* update stream block */
  block->btype = RAW;
  block->data = data;

  return block;
}
