/* $Id: crc32.c,v 1.1.1.1 2001/03/21 20:11:36 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 * 
 * crc32.c: crc-32 routines
 */

#include <netinet/in.h>

#define CRC_POLY 0x04C11DB7L

unsigned long crc_tab[256];
int crc_tab_defined = 0;

void gen_crc_tab()
     /* generate the table of CRC remainders prefixes */
{ 
  unsigned i, j;  
  unsigned long crc;
  
  for ( i = 0;  i < 256;  i++ ) {
    crc = i << 24;
    for (j=0; j<8; j++) {
      if ( crc & 0x80000000L )
	crc = (crc << 1) ^ CRC_POLY;
      else
	crc = (crc << 1); 
    }
    crc_tab[i] = crc; 
  }
  
  crc_tab_defined = 1;
}

static unsigned long update_crc(unsigned long crc_accum, char *data_blk_ptr,
                                                    int data_blk_size)
 /* update the CRC on the data block one byte at a time */
 { register int i, j;
   for ( j = 0;  j < data_blk_size;  j++ )
       { i = ( (int) ( crc_accum >> 24) ^ *data_blk_ptr++ ) & 0xff;
         crc_accum = ( crc_accum << 8 ) ^ crc_tab[i]; }
   return crc_accum; }


unsigned long update_crc4 (unsigned long crc, unsigned long word)
{
  unsigned long nword = htonl (word);
  if (!crc_tab_defined)
    gen_crc_tab();
  return update_crc (crc, (char*)&nword, sizeof(nword));
}

