/* $Id: dumpfake.c,v 1.1 2001/04/27 00:41:54 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * dumpfake.c: produce file for fake_NID module
 */

#include "testbench.h"
#include <stdio.h>

void DumpFake (char *outfile, StreamBlock *sblock)
{
  FILE *file;
  unsigned count;

  /* open file */
  file = fopen (outfile, "w");
  if (!file) {
    printf ("Error! cannot open file %s\n", outfile);
    return;
  }

  /* dump raw blocks */
  while (sblock) {
    if (sblock->btype == RAW) {
      fprintf (file, "new_cell\n");
      /* dump data */
      for (count=0; count<sblock->data->entries; count++)
	fprintf (file, "%08X\n", sblock->data->data[count]);
    } /* it's a raw block */
    else if (sblock->btype == PAD) {
      unsigned pad=0;
      if (sblock->options)
	sscanf (sblock->options, "%d", &pad);
      for (count=0; count<pad; count++)
	fprintf (file, "00000000\n");
    }

    /* get next block */
    sblock = sblock->next;
  }


  /* close file */
  fclose (file);
}

