/* $Id: fake2raw.c,v 1.1.1.1 2001/03/21 20:11:36 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * fake2raw.c: read file from fake module and create raw blocks
 */

#include "testbench.h"
#include <stdio.h>

StreamBlock *ParseSim (char *filename)
{
  FILE *file;
  char line[81], *options, *p;
  StreamBlock *start, *sblock;
  unsigned idx, word;

  /* open file */
  file = fopen (filename, "r");
  if (!file) {
    printf ("error opening file %s\n", filename);
    return NULL;
  }

  /* create new stream block */
  start = sblock = NewStreamBlock (NONE);

  /* parse file */
  while (!feof(file)) {
    /* read line */
    if (fgets (line, 80, file) ) {
      /* read ok */
      if (line[0] == '\0' || line[0] == '\n' || line[0] == '\r')
	continue;		/* empty line */
      if (line[0] == '#')	
	continue;		/* comment */

      if (!strncmp (line, "new_cell", 8)) {
	/* create new block for command */
	sblock->next = NewStreamBlock (RAW);
	sblock = sblock->next;
      }
      else {
	sscanf (line, "%x", &word);
	/* add word to block */
	AddToDataBlock (sblock->data, word);
      } /* parse number */
    } /* read line */
    
  } /* not end of file */

  /* close file */
  fclose (file);
  
  /* return stream */
  return start;
}

main (int argc, char**argv)
{
  char *infile = "CELLSOUT.DAT";
  char *outfile = "TBRAW.TBP";
  StreamBlock *sblock;

  if (argc > 1)
    infile = argv[1];
  if (argc > 2)
    outfile = argv[2];

  sblock = ParseSim (infile);

  DumpTB (outfile, sblock); 

  return 0;
}
