/* $Id: filter.c,v 1.2 2001/04/06 21:59:58 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * filter.c: functions to filter the stream blocks
 */

#include "testbench.h"
#include <stdlib.h>

StreamBlock *FilterStream (StreamBlock *stream, Filter filter)
{
  StreamBlock *newstream = NULL;
  StreamBlock **nextout = &newstream;
  StreamBlock *nextin;

  /* traverse stream */
  while (stream) {
    /* save next */
    nextin = stream-> next;
    stream->next = NULL;	/* cut here */

    /* call filter */
    *nextout = (*filter)(stream);

    /* find end */
    while (*nextout)
      nextout = &((*nextout)->next);

    /* get next */
    stream = nextin;
  }

  return newstream;

}


StreamBlock *FilterAll (StreamBlock *sblock)
{
  sblock = FilterStream (sblock, UDPFilter);
  sblock = FilterStream (sblock, IPv4Filter);
  sblock = FilterStream (sblock, IPv6Filter);
  sblock = FilterStream (sblock, FrameFilter);
  sblock = FilterStream (sblock, CtrlCellFilter);
  sblock = FilterStream (sblock, CellFilter);

  return sblock;
}

StreamBlock *ReassembleAll (StreamBlock *sblock)
{
  sblock = FilterStream (sblock, RACellFilter);
  sblock = FilterStream (sblock, RACtrlCellFilter);
  sblock = FilterStream (sblock, RAFrameFilter);
  sblock = FilterStream (sblock, RAIPv4Filter);
  sblock = FilterStream (sblock, RAUDPFilter);
  return sblock;
}

