/* $Id: inccrc32.c,v 1.1.1.1 2001/03/21 20:11:36 florian Exp $
 *
 * (c) 2001, Applied Research Lab, Washington University, St. Louis
 *
 * IP testbench tools
 * generate testpatterns for FPX modules
 *
 * ttldec.c: decrement ttl in ip header, update aal5 crc, works on cells
 */

#include <stdlib.h>

int tabs_initialized = 0;
unsigned long crc_ttl_tab[256];
unsigned long crc_hcslo_tab[256];
unsigned long crc_hcshi_tab[256];
unsigned long crc_inc_tab[4][256];
extern unsigned long crc_tab[256];
extern int crc_tab_defined;

void gen_inc_tab (unsigned long* tab, int offs)
{
  unsigned i, j, update;

  for (i=0; i<256; i++) {
    update = i << 24;
    for (j=0; j<offs; j++) {
      update = (update << 8) ^ crc_tab [(update >> 24) & 0xFF];
    }
    tab[i] = update;
  }
}

void gen_tabs()
{
  if (!crc_tab_defined)
    gen_crc_tab();
  
  gen_inc_tab (crc_ttl_tab, 36);
  gen_inc_tab (crc_hcshi_tab, 34);
  gen_inc_tab (crc_hcslo_tab, 33);
  gen_inc_tab (crc_inc_tab[3], 48);
  gen_inc_tab (crc_inc_tab[2], 47);
  gen_inc_tab (crc_inc_tab[1], 46);
  gen_inc_tab (crc_inc_tab[0], 45);
}

